﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Net.Sockets;
using System.Threading;

namespace Client
{
	class Client
	{
		private string user;
		private Socket sock;
		private NetworkStream stream;
		private StreamWriter writer;
		private StreamReader reader;

		public void Connect(string host, int port, string name)
		{
			String ans;
			this.user = name;
			this.sock = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
			try
			{
				this.sock.Connect(host, port);
			}
			catch (SocketException e)
			{
				Console.WriteLine("Error: Connexion failed\n" + e.SocketErrorCode);
				return;
			}
			this.stream = new NetworkStream(sock);
			this.writer = new StreamWriter(stream);
			this.reader = new StreamReader(stream);

			writer.WriteLine(name);
			writer.Flush();
			ans = reader.ReadLine();
			if (ans.CompareTo("Welcome") == 0)
				Console.WriteLine("Confirmation : Welcome");
			else
				Console.WriteLine("You're blacklisted, get lost\nmessage: " + ans);
		}

		public bool IsConnected()
		{
			return this.sock.Connected;
		}

		public void Run()
		{
			Thread r, w;

			r = new Thread(Run);
			w = new Thread(Write);
			r.Start();
			w.Start();

			r.Join();
			w.Join();

			this.Close();
		}

		public void Read()
		{
			if (this.sock.Poll(-1, SelectMode.SelectRead))
				Console.WriteLine(this.reader.ReadToEnd());
		}

		public void Write()
		{
			this.writer.Write(Console.ReadLine());
			this.writer.Flush();
		}

		public void Close()
		{
			this.writer.Flush();
			this.writer.Close();
			this.reader.Close();
			this.stream.Close();
			this.sock.Close();
		}
	}
}
