﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Net.Sockets;

namespace Serveur
{
	class Client
	{
		private string user;
		private Socket sock;
		private NetworkStream stream;
		private StreamWriter writer;
		private StreamReader reader;

		public Client(string name, string host, int port, Socket sock)
		{
			this.user = name;
			this.sock = sock;
			this.stream = new NetworkStream(this.sock);
			this.writer = new StreamWriter(this.stream);
			this.reader = new StreamReader(this.stream);
		}

		public bool IsConnected()
		{
			return this.sock.Connected;
		}

		public void Send(string message)
		{
			this.writer.Write(message);
			this.writer.Flush();
		}

		public string Receive()
		{
			if (this.sock.Poll(-1, SelectMode.SelectRead))
				return this.reader.ReadToEnd();
			return null;
		}

		public void Close()
		{
			this.writer.Flush();
			this.writer.Close();
			this.reader.Close();
			this.stream.Close();
			this.sock.Close();
		}
	}
}
